#ifndef INCLUDED_APPLICATION_HPP_2008_08_02_0000
#define INCLUDED_APPLICATION_HPP_2008_08_02_0000

#include <Ice/Application.h>

namespace matt {

  class BaseApplication : virtual public Ice::Application {
  };

  template< typename T >
  class Application : public BaseApplication {
    int run(int argc, char * argv[]);
  };
}

template< typename T >
int matt::Application< T >::run(
  int argc,
  char * argv[]) {
  T impl(communicator());
  impl.run();
  return 0;
}

#endif 

